// Starsiege voting script, by Orogogus
// Last edited: 4/Mar/2001 20:58

$SSVote::PlayerToKick = 0;
$SSVote::VoteInProgress = 0;
$SSVote::CurrentMeasure = 0;
$SSVote::VoteTimeOutSecs = 10;
$SSVote::GameState = 0;  // 0 = prestart/in progress, 2 = done
if($SSVote::settings != 1)
{
  $SSVote::Votestamp = 0;
  $SSVote::settings = 1;
  $server::Respawn = "true";
  $server::TeamDamage = "true";
}

%playercount = playerManager::getPlayerCount();
for(%i=0; %i<%playerCount; %i++)
{
  %player = playerManager::getPlayerNum(%i);
  %player.SSVote::Selection = 0;
  %player.SSVote::CurrentVote = 0;
  %player.SSVote::PlayerToKick = 0;
  %player.spawned = 0;
}

function player::OnAdd(%player)
{
  %player.SSVote::Selection = 0;
  %player.SSVote::CurrentVote = 0;
  %player.SSVote::PlayerToKick = 0;
  %player.spawned = 0;
  say(%player, 0, "Testing a voting script.  Please download and use the keymap - http://home.san.rr.com/orogogus/VotingKeymap.cs.");
}

function vehicle::OnAdd(%vehicle)
{
  %player = playerManager::vehicleIDToPlayerNum(%vehicle);
  say(%player, 0, "If you have the keymap loaded, use the greater than and less than signs to cycle through vote options, and CTRL-Y and CTRL-N for selecting or voting Yes and No.");

  if($server::Respawn == "false")
    {
    if(%player.spawned == 1)
    {
      schedule("damageObject(" @ %vehicle @ ", 50000);", 1);
      say(%player, 0, "Respawn has been disabled.  Please wait for the next map in the rotation.");
      return;
    }
    %player.spawned = 1;
  }
}

function vehicle::OnDestroyed(%destroyed, %destroyer)
{
  if($SSVote::GameState == 2) return;

  %destroyedPlayer = playerManager::vehicleIDToPlayerNum(%destroyed);
  %destroyedPlayer.spawned = 2;

  vehicle::onDestroyedLog(%destroyed, %destroyer);
  %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
  if(%message != "") say( 0, 0, %message);
  if($server::TeamPlay == true)
  {
    if((getTeam(%destroyed) == getTeam(%destroyer)) && (%destroyed != %destroyer)) antiTeamKill(%destroyer);
  }   

  if($server::Respawn == "false")
  {
    if($server::TeamPlay == "false")
    {
      %theLiving = 0;
      %mostKills = 0;
      %playercount = playerManager::getPlayerCount();
      for(%i=0; %i<%playerCount; %i++)
      {
        %player = playerManager::getPlayerNum(%i);

        if(getKills(%player) > %mostKills)
        {
          %killerPlayer = %player;
          %mostKills = getKills(%player);
        }
 
        if(%player.spawned == 1)
        {
          %theLiving++;
          %lastPlayer = %player;
        }
      }
      if(%theLiving == 1)
      {
        say(0, 0, "Mission over.  Last player standing: " @ getName(%lastPlayer) @ ".  Most kills: " @ %killerPlayer @ " (" @ %mostKills @ " kills)");
        say(0, 0, "Next mission starts in 5 seconds");
        $SSVote::GameState = 2;
        schedule("missionEndConditionMet();", 5);
      }

      if(%theLiving == 0)
      {
        say(0, 0, "Mission over.  No one wins");
        say(0, 0, "Next mission starts in 5 seconds");
        $SSVote::GameState = 2;
        schedule("missionEndConditionMet();", 5);
      }

    }

    if($server::TeamPlay == "true")
    {

      %teamCount = 0;
      %yellow = 0;
      %blue = 0;
      %red = 0;
      %purple = 0;

      %playercount = playerManager::getPlayerCount();
      for(%i=0; %i<%playerCount; %i++)
      {
        %player = playerManager::getPlayerNum(%i);

        if(getTeam( %player ) == *IDSTR_TEAM_YELLOW)
        {
          if(%yellow == 0)
          {
            %yellow = 1;
            %teamCount = %teamCount + 1;
          }
        } 
        if(getTeam( %player ) == *IDSTR_TEAM_BLUE)
        {
          if(%blue == 0)
          {
            %blue = 1;
            %teamCount = %teamCount + 2;
          }
        } 
        if(getTeam( %player ) == *IDSTR_TEAM_RED)
        {
          if(%red == 0)
          {
            %red = 1;
            %teamCount = %teamCount + 4;
          }
        } 
        if(getTeam( %player ) == *IDSTR_TEAM_PURPLE)
        {
          if(%purple == 0)
          {
            %purple = 1;
            %teamCount = %teamCount + 8;
          }
        }

        if(%teamCount == 1)
        {
          messageBox(0, "Yellow Team wins the round!");	
          say(0, 0, "Next mission starts in 5 seconds");
          $SSVote::GameState = 2;
          schedule("missionEndConditionMet();", 5);
        }
        else if(%teamCount == 2)
        {
          messageBox(0, "Blue Team wins the round!");	
          say(0, 0, "Next mission starts in 5 seconds");
          $SSVote::GameState = 2;
          schedule("missionEndConditionMet();", 5);
        }
        else if(%teamCount == 4)
        {
          messageBox(0, "Red Team wins the round!");	
          say(0, 0, "Next mission starts in 5 seconds");
          $SSVote::GameState = 2;
          schedule("missionEndConditionMet();", 5);
        }
        else if(%teamCount == 8)
        {
          messageBox(0, "Purple Team wins the round!");	
          say(0, 0, "Next mission starts in 5 seconds");
          $SSVote::GameState = 2;
          schedule("missionEndConditionMet();", 5);
        }
        else if(%teamCount == 0)  // This shouldn't ever happen, but...
        {
          messageBox(0, "Everyone's dead, game is a draw");	
          say(0, 0, "Next mission starts in 5 seconds");
          $SSVote::GameState = 2;
          schedule("missionEndConditionMet();", 5);
        }
      }
    }
  }
}


//======================


function SSVote::Endmission()
{
  say(0, 0, "***Vote passes: Mission ends in 5 seconds***");
  SSVote::clearVotes();
  $SSVote::GameState = 2;
  schedule("missionEndConditionMet();", 5);
  fileWrite( "multiplayer\\VotingLog.cs" , append, getDate() @ " " @ getTime() @ ": Voted to skip mission -- " @ $server::Mission );
}


function SSVote::KickPlayer()
{
  SSVote::clearVotes();
  %player = $SSVote::PlayerToKick;
  %name = getName(%player);
  %ip = getConnection(%player);

  kick(%player, "Kicked off the server by vote");
  say(0, 0, "***Vote passes: " @ %name @ " was kicked off the server***");
  fileWrite( "multiplayer\\VotingLog.cs" , append, getDate() @ " " @ getTime() @ ": Voted to kick player. " @ %name @ ", " @ %ip);
}


function SSVote::Respawn()
{
  SSVote::clearVotes();
  if($server::Respawn == "true") 
  {
    $server::Respawn = "false";
    say(0, 0, "**Vote passes: Respawn disabled**");
  }

  else if($server::Respawn == "false" || $server::Respawn == "") 
  {
    $server::Respawn = "true";
    say(0, 0, "**Vote passes: Respawn enabled**");
  }

  say(0, 0, "***Mission ends in 5 seconds***");
  fileWrite( "multiplayer\\VotingLog.cs" , append, getDate() @ " " @ getTime() @ ": Voted to set respawn " @ $server::Respawn);
  $SSVote::GameState = 2;
  schedule("missionEndConditionMet();", 5);
}


function SSVote::TeamDamage()
{
  SSVote::clearVotes();
  if($server::TeamDamage == "true") 
  {
    $server::TeamDamage = "false";
    say(0, 0, "**Vote passes: Team damage disabled**");
  }

  else if($server::TeamDamage == "false" || $server::TeamDamage == "") 
  {
    $server::TeamDamage = "true";
    say(0, 0, "**Vote passes: Team damage enabled**");
  }

  fileWrite( "multiplayer\\VotingLog.cs" , append, getDate() @ " " @ getTime() @ ": Voted to set team damage " @ $server::TeamDamage);
}

//=====================


function SSVote::clearVotes()
{
  %playercount = playerManager::getPlayerCount();
  for(%i=0; %i<%playerCount; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    %player.SSVote::CurrentVote = 0;
  }
}

function SSVote::echoVote(%player)
{
  if(%player.SSVote::Selection == 1) // End Mission
  {
    say(%player, 0, "Initiate a vote to end the current mission?");
    %player.SSVote::Selection = 1;
  }

  if(%player.SSVote::Selection == 2) // Kick Player
  {
    say(%player, 0, "Initiate a vote to kick a player?");
    %player.SSVote::Selection = 2;
  }

  if(%player.SSVote::Selection == 3) // Respawn
  {
    if($server::Respawn == "false") %text = "on?";
     else %text = "off?";
    say(%player, 0, "Initiate a vote to end the mission and turn respawn " @ %text);
    %player.SSVote::Selection = 3;
  }

  if(%player.SSVote::Selection == 4) // Team Damage
  {
    if($server::TeamDamage == "false") %text = "on?";
     else %text = "off?";
    say(%player, 0, "Initiate a vote to set team damage " @ %text);
    %player.SSVote::Selection = 4;
  }
}


function SSVote::SetHudTimerAll(%time, %increment, %string, %channel)
{
  %count = playerManager::getPlayerCount();
  for(%i=0; %i<%count; %i++)
  {
   %player = playerManager::getPlayerNum(%i);
   setHudTimer(%time, %increment, %string, %channel, %player);
  }
}


function SSVote::StartVote(%player, %vote)
{
  $SSVote::VoteInProgress = 1;
  $SSVote::CurrentMeasure = %vote;
  %player.SSVote::Selection = 0;
  %player.SSVote::CurrentVote = 1;

  %text1 = "***" @ getName(%player) @ " initiates a vote to ";
  if(%vote == 1) %text2 = "end the current mission***";
  if(%vote == -2)
  {
    %name = getName(%player.SSVote::PlayerToKick);
    $SSVote::PlayerToKick = %player.SSVote::PlayerToKick;
    %text2 = "to kick " @ %name @ "***";
  }
  if(%vote == 3)
  {
    if($server::Respawn == "false") %text = "on";
     else %text = "off";
    %text2 = "end the current mission and turn respawn " @ %text @ "***";
  }
  if(%vote == 4)
  {
    if($server::TeamDamage == "true") %text = "off";
     else %text = "on";
    %text2 = "turn team damage " @ %text @ "***";
  }

  say(0, 0, %text1 @ %text2);

  SSVote::SetHudTimerAll($SSVote::VoteTimeOutSecs, -1, "Vote timeout", 1);

  %temp = $SSVote::VoteStamp;
  schedule("SSVote::VoteTimeOut(" @ %temp @ ");", $SSVote::VoteTimeOutSecs);
  SSVote::TallyVotes();
}


function SSVote::TallyVotes()
{
  %tally = 0;
  %abstains = 0;
  %playerCount = playerManager::getPlayerCount();
  for(%i=0; %i<%playerCount; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    %tally = %tally + %player.SSVote::CurrentVote;
    if(%player.SSVote::CurrentVote == 0) %abstains++;
  }

  %neededVotes = floor(%playerCount / 2) + 1;

  if(%tally >= %neededVotes)            // Measure passes
  {
    SSVote::clearVotes();
		SSVote::SetHudTimerAll(0, 0, "", 1);
    $SSVote::VoteInProgress = 0;
    $SSVote::Votestamp++;
    if($SSVote::CurrentMeasure == 1) SSVote::EndMission();
    if($SSVote::CurrentMeasure == -2) SSVote::KickPlayer();
    if($SSVote::CurrentMeasure == 3) SSVote::Respawn();
    if($SSVote::CurrentMeasure == 4) SSVote::TeamDamage();
  }

  if(%tally < (%neededVotes * -1) )    // Measure fails
  {
    say(0, 0, "**Vote turned down by the majority**");
    SSVote::clearVotes();
		SSVote::SetHudTimerAll(0, 0, "", 1);
    $SSVote::VoteInProgress = 0;
    $SSVote::Votestamp++;
  }

  if(%abstains == 0 && %tally < %neededVotes)   // Measure fails
  {
    say(0, 0, "**Insufficient votes to pass**");
    SSVote::clearVotes();
		SSVote::SetHudTimerAll(0, 0, "", 1);
    $SSVote::VoteInProgress = 0;
    $SSVote::Votestamp++;
  }
}


function SSVote::VoteTimeOut(%votestamp)
{
  if(%votestamp != $SSVote::Votestamp) return;
  else
  {
    say(0, 0, "**Vote fails by timeout**");
    SSVote::clearVotes();
		SSVote::SetHudTimerAll(0, 0, "", 1);
    $SSVote::Votestamp++;
    $SSVote::VoteInProgress = 0;
  }
}


//=====================


function remoteSSVote::NextVote(%player)
{
  if($SSVote::VoteInProgress == 1)
  {
    say(%player, 0, "Vote in progress.  Please wait to try again.");
    return;
  }

  if(%player.SSvote::Selection == 0) %player.SSvote::Selection = 1;

  else if (%player.SSvote::Selection == -2)
  { 
    %playerCount = playerManager::getPlayerCount();
    for(%i=0; %i<%playerCount; %i++)
    {
      %target = playerManager::getPlayerNum(%i);
      if(%target == %player.SSVote::PlayerToKick) %newTarget = playerManager::getPlayerNum(%i+1);
      if(%target == %player.SSVote::PlayerToKick && (%i+1) == %playerCount) %newTarget = playerManager::getPlayerNum(0);
    }

    %player.SSVote::PlayerToKick = %newTarget;
    say(%player, 0, "Current selection: " @ getName(%player.SSVote::PlayerToKick) );
  }

  else if(%player.SSvote::Selection == 4) %player.SSvote::Selection = 1;
  else %player.SSvote::Selection++;

  SSVote::echoVote(%player);
}


function remoteSSVote::PrevVote(%player)
{
  if($SSVote::VoteInProgress == 1)
  {
    say(%player, 0, "Vote in progress.  Please wait to try again.");
    return;
  }

  if(%player.SSvote::Selection == 0) %player.SSvote::Selection = 1;
  else if(%player.SSvote::Selection == 1) %player.SSvote::Selection = 4;
  else if (%player.SSvote::Selection == -2)
  { 
    %playerCount = playerManager::getPlayerCount();
    for(%i=(%playerCount - 1); %i>-1; %i--)
    {
      %target = playerManager::getPlayerNum(%i);
      if(%target == %player.SSVote::PlayerToKick) %newTarget = playerManager::getPlayerNum(%i-1);
      if(%target == %player.SSVote::PlayerToKick && %i == 0) %newTarget = playerManager::getPlayerNum(%playerCount -1);
    }

    %player.SSVote::PlayerToKick = %newTarget;
    say(%player, 0, "Current selection: " @ getName(%player.SSVote::PlayerToKick) );
  }
  else %player.SSvote::Selection--;

  SSVote::echoVote(%player);
}


function remoteSSVote::VoteYes(%player)
{
  if($SSVote::VoteInProgress == 0 && %player.SSVote::Selection == 0) return;

  if($SSVote::VoteInProgress == 0 && %player.SSVote::Selection == 2)  // special case for kicking players, secondary menu needed
  {
    %player.SSVote::Selection = -2;
    say(%player, 0, "Initiate a vote to kick, current selection: " @ getName(playerManager::getPlayerNum(0) ) );
    %player.SSVote::PlayerToKick = playerManager::getPlayerNum(0);
    return;
  }

  if($SSVote::VoteInProgress == 0 && %player.SSVote::Selection == -2)
  {
    SSVote::StartVote(%player, %player.SSVote::Selection);
  }

  if($SSVote::VoteInProgress == 0 && %player.SSVote::Selection > 0)
  {
    SSVote::StartVote(%player, %player.SSVote::Selection);
  }
  else if($SSVote::VoteInProgress == 1)
  {
    %player.SSVote::CurrentVote = 1;
    %nays = 0;
    %abstains = 0;
    %yeas = 0;
    %playerCount = playerManager::getPlayerCount();
    for(%i=0; %i<%playerCount; %i++)
    {
      %tempPlayer = playerManager::getPlayerNum(%i);
      if(%tempPlayer.SSVote::CurrentVote == -1) %nays++;
      if(%tempPlayer.SSVote::CurrentVote == 0) %abstains++;
      if(%tempPlayer.SSVote::CurrentVote == 1) %yeas++;
    }
    say(%player, 0, "You voted yea.  Current count: " @ %yeas @ " yeas, " @ %nays @ " nays and " @ %abstains @ " abstentions.");
    SSVote::TallyVotes();
  }
}


function remoteSSVote::VoteNo(%player)
{
  if($SSVote::VoteInProgress == 0 && %player.SSVote::Selection == 0) return;
  if($SSVote::VoteInProgress == 0 && %player.SSVote::Selection > 0)
  {
    say(%player, 0, "Cancelled");
    %player.SSVote::Selection = 0;
  }
  if($SSVote::VoteInProgress == 0 && %player.SSVote::Selection == -2)
  {
    say(%player, 0, "Cancelled");
    %player.SSVote::Selection = 0;
  }

  else if($SSVote::VoteInProgress == 1)
  {
    %player.SSVote::CurrentVote = -1;
    %nays = 0;
    %abstains = 0;
    %yeas = 0;
    %playerCount = playerManager::getPlayerCount();
    for(%i=0; %i<%playerCount; %i++)
    {
      %tempPlayer = playerManager::getPlayerNum(%i);
      if(%tempPlayer.SSVote::CurrentVote == -1) %nays++;
      if(%tempPlayer.SSVote::CurrentVote == 0) %abstains++;
      if(%tempPlayer.SSVote::CurrentVote == 1) %yeas++;
    }
    say(%player, 0, "You voted nay.  Current count: " @ %yeas @ " yeas, " @ %nays @ " nays and " @ %abstains @ " abstentions.");
    SSVote::TallyVotes();
  }
}



